  if (window.JpegCamera) {
    $(function() {        
       // Init des localstorage
        if(localStorage.getItem('optionSynthese')=='true') {
            $("#optionSynthese").prop('checked','checked');
        }
        if(localStorage.getItem('optionRecognition')=='true') {
            if(typeof require!="function"){
                $("#optionRecognition").prop('checked','checked');
                recognitionStart();
            }
        }
        if(localStorage.getItem('fps')) {
            $("#framerateSelection").children().prop('selected');
            $("#framerateSelection option[value=\""+localStorage.getItem('fps')+"\"]").children().prop('selected');
        }
                
        if (typeof require === "function") {// Si on est dans l'app offline
//            require('nw.gui').Window.get().showDevTools();
        }
        
        currentVersion=[1,1,3];
        $("#version").text("Version "+currentVersion[0]+"."+currentVersion[1]+"."+currentVersion[2]);
        
    
        
        // Updater, si on est offline
        if (typeof require === "function")
        {
            var newVersion = function() {
                $("#fconsole").html("A new version is available. <a class='link' href='http://www.heronanimation.brick-a-brack.com/downloads/' target=_blank>Click here to download it.</a>");

                $('a[target=_blank]').on('click', function(){
                    require('nw.gui').Shell.openExternal( this.href );
                    return false;
                });

            }
            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://www.heronanimation.brick-a-brack.com/downloads/latest/version.json?'+(Math.random()*100), true);

            xhr.onload = function(e) {
              if (this.status == 200) {
                    var obj = jQuery.parseJSON(this.responseText);
                    version = (obj.version).split(".");
                    if(currentVersion[0]<parseInt(version[0])) newVersion();
                    else if(currentVersion[0]==parseInt(version[0])){
                        if (currentVersion[1]<parseInt(version[1])) newVersion();
                        else if(currentVersion[1]==parseInt(version[1]))
                        {
                            if (currentVersion[2]<parseInt(version[2])) newVersion();
                        }
                    }                        
              }
            };

            xhr.send();    
        }   
    });


    // Les contrôles au clavier
    $(document).keydown(function(e) {
          if($("#overlay").is(':hidden')){
            currentFrame=$('.selected:first').attr('id');
            frameNumber=parseInt($("#frameNumber").text());
                if(e.which == 39 || e.which == 37 || e.which == 49 || e.which == 50) {
                    // Flèche droite/gauche, PAV NUM 1/2

                    if(currentFrame==undefined){ 
                        currentFrame=frameNumber+1;
                    }
                    currentFrame=parseInt(currentFrame);

                    if(e.which == 37 || e.which == 49) nextFrame = currentFrame-1;
                    else if(e.which == 39|| e.which == 50) nextFrame = currentFrame+1;

                    
                    if(currentFrame==frameNumber && (e.which == 39 || e.which == 50)) {// Si on est sur la dernière image prise et qu'on avance, on revient au stream
                        show_stream();
                    }
                    else if(currentFrame==frameNumber+1 && (e.which == 39 ||e.which == 50)){}//Si on est sur le stream et qu'on avance.
                    else if(currentFrame==1 && (e.which == 37 ||e.which == 49)){}
                    else select_snapshot(nextFrame);// Sinon on affiche l'image (si on n'est ps sur la première et qu'on -1)
                }
              
              if(e.which == 51) show_stream();

              if(e.which == 13) {// Entrée : prendre photo
                  if($("video:first").length>0)
                  {
                      event.preventDefault();
                      take_snapshots(1);
                  }
              }

              if(e.which == 46 || e.which == 8) {// Suppr : supprimer photo
                        discard_snapshot();
              }

              if(e.which == 32 || e.which == 48) {// Espace, 0 : lecture
                  event.preventDefault();
                  if(frameNumber>0)
                  {
                      if($("#play").is(':hidden')){
                          setPause();
                      }
                      else play();
                  }
              }

              if(e.which == 56) {// 8 : Bloucle
                  loop();
              }

              if(e.which == 55) {// 7 : Difference
                  difference();
              }

              if(e.which == 107) {// + : onion+
                  onion(true);
              }
              if(e.which == 109) {// - : onion-
                  onion(false);
              }
          }
        });

        
    var options = {
      swf_url: "dist/jpeg_camera.swf",
    }

    var newCamera = function() {
        
        camera = new JpegCamera("#camera", options).ready(function(info) {
            
            $("#take_snapshots").removeClass("disabled");

            $("#camera_info").html(info.video_width + "x" + info.video_height);

            
            $(".loadingAnimation").css("display","none");
            $(".box").css("opacity","1");
            
            contextMenu();
//            windowsResize();    
        });
    }
    
    var setDisplaySize = function() {

        $("#camera").height("500px");
        $("#camera").width("889px");
        
        
        if($("video:first").length==0)
        {
            setTimeout(setDisplaySize,100);
        }
        else {
            $("video:first").css('width','initial');
            
            windowHeight=$(window).height();
            windowWidth=$(window).width();
            bottomHeight = $("#bottomUI").height();
            
            videoWidth=$("video:first").width();
            videoEight=$("video:first").height();
            videoRatio=videoWidth/videoEight;
            
            if(windowWidth<=1080) espaceDisponible=(windowWidth/videoRatio)-125;
            else espaceDisponible=windowHeight-bottomHeight-125;
            
            $("#camera").height(Math.round(espaceDisponible));
            $(".box").height(Math.round(espaceDisponible-50));
            
            $("#hautContainer").css("text-align","center");
            
            
            $("#camera > div > canvas").css("width",$("video:first").width());
            $("#camera > div > canvas").css("height",$("video:first").height());
            

            
            
            if(windowWidth<espaceDisponible*videoRatio) {
                scaleRatio=(windowWidth)/(espaceDisponible*videoRatio);
                scaleRatio=1;
            }
            else scaleRatio=espaceDisponible/videoEight;
            
            $("video:first").parent().css("transform-origin","0 0");
            $("video:first").parent().css("transform","scale("+scaleRatio+")");
            $("#camera > div > canvas").css("transform-origin","0 0");
            $("#camera > div > canvas").css("transform","scale("+scaleRatio+")");
//            $("video:first").parent().height(espaceDisponible)
//            $("video:first").height(espaceDisponible)
//            $("video:first").width(espaceDisponible*videoRatio)
            
            newBoxWidth=(($("video:first").width()*scaleRatio));
            $("#camera").width(Math.round(newBoxWidth));
            $(".box").css("width",(Math.round(newBoxWidth+50)));

        }
    }


    // Sélection de l'appareil de prise de vue.
    navigator.mediaDevices.enumerateDevices().then(function(devices) {
        chooseText=window.textVariables.chooseText;
        $("#cameraDeviceLabel").append("<label id='cameraDeviceText' for='device'></label>");
        $("#cameraDeviceCont").append("<select id='cameraDevice' name='device'><option id='chooseDeviceText'>"+chooseText+"</option></select>");
        defaultDevice='';
        devices.forEach(function(device) {
            
            if(device.kind=="videoinput"){
                $("#cameraDevice").append("<option value='"+device.deviceId+"' >"+device.label+"</option>");
                defaultDevice=device.deviceId;
            }
      });
        $("#cameraDevice>option:last").attr("selected","selected");  
         
        jQuery("select").focusin(function () { toggleEnableSelectStart(true); });
        jQuery("select").mouseover(function () { toggleEnableSelectStart(true); });
        jQuery("select").focusout(function () { toggleEnableSelectStart(false); });
        jQuery("select").mouseout(function () { toggleEnableSelectStart(false); });
        
        $('#cameraDevice').on('change', function() {
            chooseDevice(this.value);
        });
        
        chooseDevice(defaultDevice);
    })
    
      
    var chooseDevice = function(deviceId) {
        $("#cameraDevice-button").css("width","auto");
          
        // Une fois que la source est choisie, on set la taille et lance la cam
        $("#camera").empty();
          
        if($("#TheChoseOne").length>0) $("#TheChoseOne").remove();
        $(".box").css("display","inline-block");
        $("#cameraDeviceText").css("display","none");
          
        $("#hautContainer").css("margin-top","0px");
          
        $(".box").append("<input type='hidden' value='"+deviceId+"' id='TheChoseOne'/>");

        setDisplaySize();
        newCamera();
    }

    
    // Redimension
    $(window).resize(function(){setDisplaySize();drawOverlay();});

      
    // Confirmation quand on quitte
    var confirmOnLeave = function(msg)
    {
        $(function(){
            window.onbeforeunload = function (e)
            {
                msg=window.textVariables.exitMessage;
                if($("#optionSynthese").prop('checked'))
                {
                    u = new SpeechSynthesisUtterance();
                    if($("#lang").val()=='fr')
                    {
                        u.lang = 'fr-FR';
                        u.text = 'Non, ne me laisse pas seul.';
                    }
                    else{
                        u.lang = 'en-EN';
                        u.text = 'No, don\'t leave me alone.';
                    }
                    speechSynthesis.speak(u);
                }

                e = e || window.event;
                msg = msg || '';
                if (e)
                    e.returnValue = msg;
                return (msg);
            };
        });
    }
    confirmOnLeave();
      
    $(function(){
        document.getElementById("overlay").onmousedown = function (e) { return (false); };
        document.getElementById("overlay").onmouseup = function (e) { return (false); };
        document.getElementById("hautContainer").onmousedown = function (e) { return (false); };
        document.getElementById("hautContainer").onmouseup = function (e) { return (false); };
        document.getElementById("toolbar").onmousedown = function (e) { return (false); };
        document.getElementById("toolbar").onmouseup = function (e) { return (false); };
        jQuery("input[type=text]").focusin(function () { toggleEnableSelectStart(true); });
        jQuery("input[type=text]").mouseover(function () { toggleEnableSelectStart(true); });
        jQuery("input[type=text]").focusout(function () { toggleEnableSelectStart(false); });
        jQuery("input[type=text]").mouseout(function () { toggleEnableSelectStart(false); });
        jQuery("input[type=number]").focusin(function () { toggleEnableSelectStart(true); });
        jQuery("input[type=number]").mouseover(function () { toggleEnableSelectStart(true); });
        jQuery("input[type=number]").focusout(function () { toggleEnableSelectStart(false); });
        jQuery("input[type=number]").mouseout(function () { toggleEnableSelectStart(false); });
        jQuery("select").focusin(function () { toggleEnableSelectStart(true); });
        jQuery("select").mouseover(function () { toggleEnableSelectStart(true); });
        jQuery("select").focusout(function () { toggleEnableSelectStart(false); });
        jQuery("select").mouseout(function () { toggleEnableSelectStart(false); });
    });
      
    function toggleEnableSelectStart(enable) {
        document.getElementById("overlay").onmousedown = function (e) { return enable; };
        document.getElementById("overlay").onselectstart = function (e) { return enable; };
        document.getElementById("toolbar").onmousedown = function (e) { return enable; };
        document.getElementById("toolbar").onselectstart = function (e) { return enable; };
    }
}